/*
] * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import java.math.BigDecimal;
import java.util.Calendar;
import java.util.List;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zkplus.databind.BindingListModel;
import org.zkoss.zkplus.databind.BindingListModelList;
import org.zkoss.zul.Button;
import org.zkoss.zul.Checkbox;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.constantes.Constantes;
import com.rjconsultores.ventaboletos.entidad.AliquotaEstadoDestino;
import com.rjconsultores.ventaboletos.entidad.EmpresaImposto;
import com.rjconsultores.ventaboletos.entidad.Estado;
import com.rjconsultores.ventaboletos.service.AliquotaEstadoDestinoService;
import com.rjconsultores.ventaboletos.service.ConstanteService;
import com.rjconsultores.ventaboletos.service.EmpresaImpostoService;
import com.rjconsultores.ventaboletos.service.EstadoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderAliquotaEstadoDestino;


/**
 * 
 * @author Rafius
 */
@Controller("editarEmpresaImpostoController")
@Scope("prototype")
public class EditarEmpresaImpostoController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	private static Logger log = LogManager.getLogger(EditarEmpresaImpostoController.class);


	private EmpresaImposto empresaImposto;

	@Autowired
	private EmpresaImpostoService empresaImpostoService;
	
	@Autowired
	private EstadoService estadoService;
	
	@Autowired
	private AliquotaEstadoDestinoService aliquotaEstaDestinoService;
	
	@Autowired
	private ConstanteService constanteService;
	
	private MyListbox empresaImpostoList;
	
	private Textbox txtAliquotaEstadoDestino;
	private Button btnAdicionarAliquotaEstadoDest;
	private Button btnRemoverAliquotaEstadoDest;
	private  Checkbox chkIndAliquotaBPeUfDestino;
	private BigDecimal aliquotaDest;
	private Combobox cmbEstadoAliquotaEstadoDestino;
	private List<Estado> lsEstadosAliquotaEstadoDestino;
	private Estado selectedEstadoAliquotaEstadoDestino;
	private MyListbox aliquotaEstadoDestinoList;
	private List<AliquotaEstadoDestino> lsAliquotaEstadoDestino;
	
	private Textbox txtIcms;
	private Textbox txtIcmsIntermunicipal;
	
	boolean desativaObrCamEmpresaImposto = false;
	

	/**
	 * @return the empresaImposto
	 */
	public EmpresaImposto getEmpresaImposto() {
		return empresaImposto;
	}

	/**
	 * @param empresaImposto
	 *            the empresaImposto to set
	 */
	public void setEmpresaImposto(EmpresaImposto empresaImposto) {
		this.empresaImposto = empresaImposto;
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		EmpresaImposto empresaImposto = (EmpresaImposto) Executions.getCurrent().getArg().get("empresaImposto");
		this.empresaImpostoList = (MyListbox) Executions.getCurrent().getArg().get("empresaImpostoList");
		this.empresaImposto = empresaImpostoService.obtenerID(empresaImposto.getEmpresaImpostoId());
		this.lsEstadosAliquotaEstadoDestino = estadoService.obtenerTodos();
		lsEstadosAliquotaEstadoDestino.remove(empresaImposto.getEstado());
		super.doAfterCompose(comp);
		aliquotaEstadoDestinoList.setItemRenderer(new RenderAliquotaEstadoDestino());
		empresaImposto.setLsAliquotaEstadoDestino(aliquotaEstaDestinoService.getChildrens(empresaImposto));
		lsAliquotaEstadoDestino = empresaImposto.getLsAliquotaEstadoDestino(); 
		aliquotaEstadoDestinoList.setData(lsAliquotaEstadoDestino);
		boolean isChecked=empresaImposto.getIndAliquotaBPeUfDestino() != null ? empresaImposto.getIndAliquotaBPeUfDestino() : false ;
		chkIndAliquotaBPeUfDestino.setChecked(isChecked);
		cmbEstadoAliquotaEstadoDestino.setDisabled(!isChecked);
		txtAliquotaEstadoDestino.setDisabled(!isChecked);
		btnAdicionarAliquotaEstadoDest.setDisabled(!isChecked);
		btnRemoverAliquotaEstadoDest.setDisabled(!isChecked);
		 
		ajustarCamposObrigatorios();
	}

	/**
	 * Ajusta obrigatoriedade dos campos conforme definicao da constante
	 * AL-4468
	 */
	private void ajustarCamposObrigatorios() {		
		try {
			txtIcms.setConstraint("no empty");
			txtIcmsIntermunicipal.setConstraint("no empty");
			txtAliquotaEstadoDestino.setConstraint("no empty");
			
			desativaObrCamEmpresaImposto = constanteService.buscarValorConstantePorNomeConstanteBoolean(Constantes.DESATIVAR_OBR_CAM_EMPRESA_IMPOSTO.toString());		
			if (desativaObrCamEmpresaImposto) {
				txtIcms.setConstraint("");
				txtIcmsIntermunicipal.setConstraint("");
				txtAliquotaEstadoDestino.setConstraint("");			
			}			
		} catch (Exception e) {
			log.error(e);			
		}
	}

	public void onClick$btnEmpresaImpostoSalvar(Event ev) throws InterruptedException {
		try {
			
			
			if(!desativaObrCamEmpresaImposto && empresaImposto.getPorctributo() == null) {
				Messagebox.show(
						Labels.getLabel("editarEmpresaImpostoController.window.obrigatorioOutrosTributos"),
						Labels.getLabel("editarEmpresaController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
				return;
			}
			
			setarValoreZero();
			
			empresaImposto.setLsAliquotaEstadoDestino(lsAliquotaEstadoDestino);
			
			empresaImpostoService.actualizacion(this.empresaImposto);
			Messagebox.show(
					Labels.getLabel("editarEmpresaImpostoController.window.sucessoSalvar"),
					Labels.getLabel("editarEmpresaController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);

			closeWindow();

		} catch (Exception ex) {

			log.error("editarEmpresaController: " + ex);
			Messagebox.show(
					Labels.getLabel("MSG.Error"),
					Labels.getLabel("editarEmpresaController.window.title"),
					Messagebox.OK, Messagebox.ERROR);
		}
	}
	
	public void onCheck$chkIndAliquotaBPeUfDestino(Event ev) throws InterruptedException {
			cmbEstadoAliquotaEstadoDestino.setDisabled(!chkIndAliquotaBPeUfDestino.isChecked());
			txtAliquotaEstadoDestino.setDisabled(!chkIndAliquotaBPeUfDestino.isChecked());
			btnAdicionarAliquotaEstadoDest.setDisabled(!chkIndAliquotaBPeUfDestino.isChecked());
			btnRemoverAliquotaEstadoDest.setDisabled(!chkIndAliquotaBPeUfDestino.isChecked());
	}
	
	public void onClick$btnAdicionarAliquotaEstadoDest(Event ev) throws InterruptedException {
		
		if(aliquotaDest == null || selectedEstadoAliquotaEstadoDestino == null) return ;
		
		AliquotaEstadoDestino a = new AliquotaEstadoDestino();
		a.setEstado(selectedEstadoAliquotaEstadoDestino);
		lsEstadosAliquotaEstadoDestino.remove(selectedEstadoAliquotaEstadoDestino);
		BindingListModel listAliquotaEstado = new BindingListModelList(lsEstadosAliquotaEstadoDestino, true);
		cmbEstadoAliquotaEstadoDestino.setModel(listAliquotaEstado);
		a.setAliquota(aliquotaDest);
		a.setEmpresaImposto(empresaImposto);
		a.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		a.setActivo(Boolean.TRUE);
		a.setFecmodif(Calendar.getInstance().getTime());
		lsAliquotaEstadoDestino.add(a);
		aliquotaEstadoDestinoList.setData(lsAliquotaEstadoDestino);
		
	}
	
	public void onClick$btnRemoverAliquotaEstadoDest(Event ev) throws InterruptedException {
		if(lsAliquotaEstadoDestino != null  && lsAliquotaEstadoDestino.size() == 0) {return;}
		int index  = aliquotaEstadoDestinoList.getSelectedItem().getIndex();
		lsEstadosAliquotaEstadoDestino.add(lsAliquotaEstadoDestino.remove(index).getEstado());
		aliquotaEstadoDestinoList.setData(lsAliquotaEstadoDestino);
	}
	

	private void setarValoreZero() {
		
		if(empresaImposto.getPorCredBaseIcms() == null) {
			empresaImposto.setPorCredBaseIcms(BigDecimal.ZERO);
		}
		
		if(empresaImposto.getPorcRedBaseIcmsIM() == null) {
			empresaImposto.setPorcRedBaseIcmsIM(BigDecimal.ZERO);
		}
		
		if(empresaImposto.getIcms() == null) {
			empresaImposto.setIcms(BigDecimal.ZERO);
		}
		if(empresaImposto.getIcmsMatricial() == null) {
			empresaImposto.setIcmsMatricial(BigDecimal.ZERO);
		}

		if(empresaImposto.getIndiceICMSIntermunicipal() == null) {
			empresaImposto.setIndiceICMSIntermunicipal(BigDecimal.ZERO);
		}
		
		if(empresaImposto.getIcmsIntermunicipal() == null) {
			empresaImposto.setIcmsIntermunicipal(BigDecimal.ZERO);
		}
		
		if(empresaImposto.getIcmsIntermunicipalMatricial() == null) {
			empresaImposto.setIcmsIntermunicipalMatricial(BigDecimal.ZERO);
		}
		
		if(empresaImposto.getIcmsIntermunicipalMatricial() == null) {
			empresaImposto.setIcmsIntermunicipalMatricial(BigDecimal.ZERO);
		}
	}

	public void onClick$btnEmpresaImpostoApagar(Event ev) { 
		try {
			int resp = Messagebox.show(
					"Deseja apagar este registro?",
					Labels.getLabel("editarEmpresaController.window.title"),
					Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

			if (resp == Messagebox.YES) {

				empresaImpostoService.borrar(this.empresaImposto);
				
				this.empresaImpostoList.removeItem(this.empresaImposto);

				Messagebox.show( 
						Labels.getLabel("editarEmpresaImpostoController.window.sucessoApagar"),
						Labels.getLabel("editarEmpresaController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);

				closeWindow();
			}
		} catch (Exception ex) {
			log.error(ex);
		}
	}

	public List<Estado> getLsEstadosAliquotaEstadoDestino() {
		return lsEstadosAliquotaEstadoDestino;
	}

	public void setLsEstadosAliquotaEstadoDestino(List<Estado> lsEstadosAliquotaEstadoDestino) {
		this.lsEstadosAliquotaEstadoDestino = lsEstadosAliquotaEstadoDestino;
	}

	public BigDecimal getAliquotaDest() {
		return aliquotaDest;
	}

	public void setAliquotaDest(BigDecimal aliquotaDest) {
		this.aliquotaDest = aliquotaDest;
	}

	public Estado getSelectedEstadoAliquotaEstadoDestino() {
		return selectedEstadoAliquotaEstadoDestino;
	}

	public void setSelectedEstadoAliquotaEstadoDestino(Estado selectedEstadoAliquotaEstadoDestino) {
		this.selectedEstadoAliquotaEstadoDestino = selectedEstadoAliquotaEstadoDestino;
	}

	public Checkbox getChkIndAliquotaBPeUfDestino() {
		return chkIndAliquotaBPeUfDestino;
	}

	public void setChkIndAliquotaBPeUfDestino(Checkbox chkIndAliquotaBPeUfDestino) {
		this.chkIndAliquotaBPeUfDestino = chkIndAliquotaBPeUfDestino;
	}
	
}
